Attribute VB_Name = "Module2"
Public Const NORMAL_PRIORITY_CLASS = &H20
Public Const IDLE_PRIORITY_CLASS = &H40
Public Const HIGH_PRIORITY_CLASS = &H80
Public Const REALTIME_PRIORITY_CLASS = &H100

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long
Declare Function GetCurrentProcess Lib "kernel32" () As Long
Declare Function SetPriorityClass Lib "kernel32" (ByVal hProcess As Long, ByVal dwPriorityClass As Long) As Long

Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Dim TimeUnit As Double
Dim StartTimeLow As Long
Dim StartTimeHigh As Long
Function TimeRead() As Double
  Dim t As LARGE_INTEGER
  If TimeUnit = 0 Then TimeUnit = 0.000838096515
  x = QueryPerformanceCounter(t)
  TimeRead = (t.highpart * 4294967296# + t.lowpart - StartTimeHigh * 4294967296# - StartTimeLow) * TimeUnit
End Function
Sub TimeInit()
  Dim f As LARGE_INTEGER
  Dim t As LARGE_INTEGER
  x = QueryPerformanceFrequency(f)
  TimeUnit = 1000 / f.lowpart
  x = QueryPerformanceCounter(t)
  StartTimeLow = t.lowpart
  StartTimeHigh = t.highpart
End Sub
Sub Delay(DelayTime As Double)
  TimeStart = TimeRead
  While TimeRead < (TimeStart + DelayTime)
  Wend
End Sub
Sub RealTime(Level As Boolean)
  If Level Then
    SetPriorityClass GetCurrentProcess(), REALTIME_PRIORITY_CLASS
  Else:
    SetPriorityClass GetCurrentProcess(), NORMAL_PRIORITY_CLASS
  End If
End Sub


